#include <bits/stdc++.h>
#define int long long
#define endl '\n'
using namespace std;
void solve()
{
    int n;
    cin>>n;
    int a[n];
    for(int i=0;i<n;i++)cin>>a[i];
    vector<pair<int,int>>v;
    for(int i=0;i<n;i++)
    {
        int mn=1e9,pos=-1;
        for(int j=i;j<n;j++)
        {
            if(a[j]<mn)
            {
                pos=j;
                mn=a[j];
            }
        }
//        cout<<i+1<<' '<<pos+1<<' '<<mn<<endl;
        v.push_back({i+1,pos+1});
//        swap(a[i],a[pos]);
        reverse(a+i,a+pos+1);
    }
//    for(int i=0;i<n;i++)cout<<a[i]<<' ';
    cout<<v.size()<<endl;
    for(auto [q,w]:v)cout<<q<<' '<<w<<endl;
}
int32_t main()
{
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);cin.tie(nullptr);
    solve();
}
